import 'package:intl/intl.dart';

extension DateTimeExtraUtils on DateTime {
  String Format(String format, [String? locale]) {
    return DateFormat(format,locale).format(this);
  }

  bool IsSameYear(DateTime other) {
    return this.year == other.year;
  }

  bool IsSameMonth(DateTime other) {
    return this.month == other.month && IsSameYear(other);
  }

  bool IsSameDay(DateTime other) {
    return this.day == other.day && IsSameMonth(other);
  } 
}