typedef bool EventCallBack(String name, dynamic param);

class _Event {
  dynamic param;
  EventCallBack? cb;
  bool once;

  _Event(this.cb,this.param,this.once);
}

class Event {
  Map<String,List<_Event>> events = {};

  void on(String name, {dynamic param, EventCallBack? cb}){
    if(!events.containsKey(name))
      events[name] = [];

    events[name]!.add(_Event(cb,param,false));
  }

  void off({String? name, EventCallBack? cb}) {
    if(name == null)
      events = {};
    else if(events.containsKey(name)) {
      if(cb == null)
        events.remove(name);
      else {
        int i = 0;
        for(var ev in events[name]!) {
          if(ev.cb == cb) {
            events[name]!.removeAt(i);
            break;
          }
          i++;
        }     
      }
    }      
  }

  void once (String name, {dynamic param, EventCallBack? cb}){
    if(!events.containsKey(name))
      events[name] = [];

    events[name]!.add(_Event(cb,param,true));
  }

  bool emit(String name) {
		if(events.containsKey(name)) {
			var listeners = events[name]!;
      var len = listeners.length - 1;

			while(len >= 0) {
        var listener = listeners[len];
        
        if(listener.once)
          listeners.removeAt(len);

        if(!listener.cb!(name,listener.param))
          return false;

				len--;
      }
    }
		
    return true;
  }
}